/*
To do:

T = needs testing
X = done
- = cancelled

[T] register Ham_Killed instead of using zpnm killed native
[T] CZ bots support
v1.1.3
[ ] 
*/

// Modules
#include <amxmodx>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

new g_zombie[33], cvar_zombie, cvar_nemesis, cvar_assassin

public plugin_init()
{
	register_plugin("[ZPNM] Blood Color Changer for Zombies", "1.1.3", "D i 5 7 i n c T")
	
	RegisterHam(Ham_BloodColor, "player", "fw_Player_BloodColor")
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayer", 1)
	RegisterHamBots(Ham_BloodColor, "fw_Player_BloodColor")
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayer", 1)
	
	cvar_zombie = register_cvar("zpnm_zm_blood_color", "193")
	cvar_nemesis = register_cvar("zpnm_nem_blood_color", "-1") //111
	cvar_assassin = register_cvar("zpnm_ass_blood_color", "215") //79
}

public plugin_cfg()
	set_task(1.57, "cache_settings")

public cache_settings()
{
	cvar_zombie = get_pcvar_num(cvar_zombie)
	cvar_nemesis = get_pcvar_num(cvar_nemesis)
	cvar_assassin = get_pcvar_num(cvar_assassin)
}

public client_disconnect(iID)
	g_zombie[iID] = false

public zpnm_user_spawn_post(iID)
	g_zombie[iID] = false

public zp_user_infected_post(iID, infector, nemesis, assassin)
{
	if (!assassin)
	{
		if (!nemesis)
			g_zombie[iID] = 1
		else
			g_zombie[iID] = 2
	}
	else
		g_zombie[iID] = 3
}

public zp_user_humanized_post(iID)
	g_zombie[iID] = false

public fwHamKilledPlayer(const iID)
	g_zombie[iID] = false

// Change blood color
public fw_Player_BloodColor(const iID)
{
	if (g_zombie[iID] == 1 && cvar_zombie > -1)
	{
		SetHamReturnInteger(cvar_zombie)
		
		return HAM_SUPERCEDE;
	}
	else if (g_zombie[iID] == 2 && cvar_nemesis > -1)
	{
		SetHamReturnInteger(cvar_nemesis)
		
		return HAM_SUPERCEDE;
	}
	else if (g_zombie[iID] == 3 && cvar_assassin > -1)
	{
		SetHamReturnInteger(cvar_assassin)
		
		return HAM_SUPERCEDE;
	}
	
	return HAM_IGNORED;
}
