#include <amxmodx>
#include <amxmisc>
#include <zp50_colorchat>
#include <zombieplaguenightmare>

public plugin_init()
{
	register_plugin("[ZPNM] Donate Ammo Packs", "1.0", "D i 5 7 i n c T")
	
	register_dictionary("zpnm_special_chat.txt")
	register_dictionary("zpnm_donate_ampks.txt")
	register_dictionary("zombie_plague.txt")
	
	register_clcmd("say", "verify_keywords")
	register_clcmd("say_team", "verify_keywords")
}

public verify_keywords(id)
{
	static arg[52]
	read_args(arg, 51)
	
	trim(arg)
	remove_quotes(arg)
	replace_all(arg, 51, "%", "")
	replace_all(arg, 51, "/", "")
	
	if (!arg[0])
		return;
	
	static arg1[7], arg2[32], arg3[10], arg4[2]
	arg2 = ""
	arg3 = ""
	arg4 = ""
	parse(arg, arg1, 6, arg2, 31, arg3, 9, arg4, 1)
	
	if (!equali(arg1, "donate") && !equali(arg1, "give"))
		return;
	
	replace_all(arg3, 9, "+", "")
	replace_all(arg3, 9, "-", "")
	replace_all(arg3, 9, "*", "")
	
	if (!arg2[0] || !arg3[0] || arg4[0])
	{
		zp_colored_print(id, "%L", id, "ZPNM_DONATE_USAGE")
		
		return;
	}
	
	static target
	target = cmd_target(id, arg2, CMDTARGET_ALLOW_SELF)
	
	if (!target)
	{
		zp_colored_print(id, "%L", id, "ZPNM_NOT_FOUND")
		
		return;
	}
	else if (id == target)
	{
		zp_colored_print(id, "%L", id, "ZPNM_YOURSELF")
		
		return;
	}
	
	static ampks_donator, amount
	ampks_donator = zp_get_user_ammo_packs(id)
	
	if (!equali(arg3, "all"))
	{
/*		static i, invalid
		invalid = false
		
		for (i = 0; i < 10; i++)
		{
			if (arg3[i] && !isdigit(arg3[i]))
			{
				invalid = true
				
				break;
			}
		}
		
		if (invalid)
		{
			zp_colored_print(id, "%L", id, "ZPNM_INVALID_AMOUNT")
			
			return;
		}
		*/
		amount = str_to_num(arg3)
		
		if (amount > ampks_donator)
		{
			zp_colored_print(id, "%L", id, "NOT_ENOUGH_AMMO")
			
			return;
		}
	}
	else
		amount = ampks_donator
	
	if (amount < 1)
	{
		zp_colored_print(id, "%L", id, "ZPNM_INVALID_AMOUNT", amount)
		
		return;
	}
	
	zp_set_user_ammo_packs(id, ampks_donator - amount)
	zp_set_user_ammo_packs(target, zp_get_user_ammo_packs(target) + amount)
	
	static rname[32]
	get_user_name(target, rname, 31)
	
	zp_colored_print(id, "^3%L", id, "ZPNM_DONATE_GIVE", amount, rname)
	
	static dname[32]
	get_user_name(id, dname, 31)
	
	zp_colored_print(target, "^3%L", target, "ZPNM_DONATE_RECEIVE", dname, amount)
}
