#include <amxmodx>
#include <zombieplaguenightmare>

new g_iAmmoPacks[33];

public plugin_init()
{
	register_plugin("[ZPNM] Display ampks as money", "0.0.3", "D i 5 7 i n c T, meTaLiCroSS")
	
	register_event("ResetHUD", "fwEventResetHUD", "b")
}

public plugin_cfg()
	set_task(0.1, "ftTaskChangeCvar")

public ftTaskChangeCvar()
	set_cvar_num("zp_remove_money", 2)

public fwEventResetHUD(const iID)
{
	remove_task(iID)
	set_task(0.1, "ftTaskUpdateAmpksAndMoneyHUD", iID, { 0 }, 1)
}

public ftTaskUpdateAmpksAndMoneyHUD(const szUpdateAndFlash[], const iID)
{
	if (szUpdateAndFlash[0])
	{
		new iAmmoPacksNew;
		
		if ((iAmmoPacksNew = zp_get_user_ammo_packs(iID)) == g_iAmmoPacks[iID])
			return;
		
		g_iAmmoPacks[iID] = iAmmoPacksNew;
	}
	
	ftMessageMoneySend(iID, g_iAmmoPacks[iID], szUpdateAndFlash[0])
}

ftMessageMoneySend(const iID, const iAmount, const bFlash)
{
	static iID_MessageMoney;
	if (!iID_MessageMoney)
		iID_MessageMoney = get_user_msgid("Money");
	
	message_begin(MSG_ONE_UNRELIABLE, iID_MessageMoney, _, iID)
	write_long(iAmount)
	write_byte(bFlash)
	message_end()
}

public zpnm_user_get_ammo_packs(iID, iAmount, iSource)
{
	g_iAmmoPacks[iID] = zp_get_user_ammo_packs(iID);
	
/*	if (iSource == AMMO_MAIN)
		return;
	*/
	remove_task(iID)
	ftMessageMoneySend(iID, g_iAmmoPacks[iID], true)
}

public zp_extra_item_selected(iID, iItemID, bIgnoreCost, iCost)
{
	if (bIgnoreCost || !iCost)
		return;
	
	remove_task(iID)
	set_task(0.1, "ftTaskUpdateAmpksAndMoneyHUD", iID, { 1 }, 1)
}
