/*
To do:

T = needs testing
X = done
- = cancelled

[T] register Ham_Killed instead of using zpnm killed native
[T] CZ bots support
v0.0.5
[ ] 
*/

// Modules
#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

public plugin_init()
{
	register_plugin("[ZPNM] Antidote Protection", "0.0.5", "D i 5 7 i n c T")
	
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayer", 1)
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayer", 1)
}

public client_disconnect(iID)
	remove_task(iID)

public zpnm_user_spawn_post(iID)
	remove_task(iID)

public zp_extra_item_selected(iID, item)
{
	if (item != EXTRA_ANTIDOTE)
		return;
	
	zpnm_set_user_no_damage(iID, 7.57)
	
	remove_task(iID)
	fm_set_rendering(iID, kRenderFxNone, 255, 255, 255, kRenderTransTexture)
	set_task(7.57, "unprotect", iID)
}

public zp_user_infected_post(iID)
	remove_task(iID)

public zp_user_humanized_post(iID)
	remove_task(iID)

public fwHamKilledPlayer(const iID)
	remove_task(iID)

public unprotect(iID)
	fm_set_rendering(iID)

// Set entity's rendering type (from fakemeta_util)
stock fm_set_rendering(entity, fx = kRenderFxNone, r = 255, g = 255, b = 255, render = kRenderNormal, amount = 0)
{
	static Float:color[3]
	color[0] = float(r)
	color[1] = float(g)
	color[2] = float(b)
	
	set_pev(entity, pev_renderfx, fx)
	set_pev(entity, pev_rendercolor, color)
	set_pev(entity, pev_rendermode, render)
	set_pev(entity, pev_renderamt, float(amount))
}
